<template>
  <a-form :form="form" @submit="handleSubmit" class="form">
    <transition name="showInfo">
      <a-alert
        v-if="notification"
        :type="notification.type"
        style="margin-bottom: 8px"
      >
        <template slot="message">
          {{ notification.message }}
        </template>
      </a-alert>
    </transition>
    <a-form-item
      v-bind="formItemLayout"
      :required="true"
      label="法人名・貴社名"
    >
      <a-input
        v-decorator="[
          'companyName',
          {
            rules: [{ validator: validateCompanyName }],
            validateTrigger: ['change', 'blur'],
            initialValue: user.companyName
          }
        ]"
        :disabled="showSubmit"
        placeholder="株式会社○○"
      />
    </a-form-item>
    <a-form-item v-bind="formItemLayout" label="法人名・貴社名(フリガナ)">
      <a-input
        v-decorator="[
          'companyNameKana',
          {
            rules: [{ validator: validateCompanyNameKana }],
            validateTrigger: ['change', 'blur'],
            initialValue: user.companyNameKana
          }
        ]"
        :disabled="showSubmit"
        placeholder="カブシキカイシャマルマル"
      />
    </a-form-item>

    <!-- xx -->
    <a-form-item
      v-bind="formItemLayout"
      :required="true"
      label="郵便番号"
      style="margin-bottom:0;"
    >
      <a-form-item
        :style="{ display: 'inline-block', width: 'calc(100% - 188px)' }"
      >
        <a-input
          v-decorator="[
            'postCode',
            {
              rules: [{ validator: validatePostCode }],
              validateTrigger: ['change', 'blur'],
              initialValue: user.postCode
            }
          ]"
          placeholder="[例] 1631435"
          autocomplete="off"
        />
        <span slot="help" v-if="noPostCode" class="text-danger">該当する住所がありません。</span>
      </a-form-item>
      <span
        :style="{
          display: 'inline-block',
          width: '8px',
          textAlign: 'center'
        }"
      />
      <a-button :style="{ display: 'inline-block', width: '180px' }" @click="generateStateCity" type="primary">
        郵便番号から住所を検索
      </a-button>
    </a-form-item>

    <a-form-item
      v-bind="formItemLayout"
      :required="true"
      label="住所"
    >
      <a-select
        v-decorator="[
          'stateCity',
          {
            rules: [{
              required: true,
              message: '都道府県を選択してください'
            }],
            initialValue: (user.stateCity && user.stateCity[0]) || undefined,
            validateTrigger: ['change'],
          }
        ]"
        :get-popup-container="triggerNode => triggerNode.parentNode"
        @change="stateChangeHanlde"
        class="w-100"
        placeholder="都道府県"
      >
        <a-icon slot="suffixIcon" type="caret-down" class="srp-darkest" />
        <a-select-option
          v-for="item in states"
          :key="item"
        >
          {{ item }}
        </a-select-option>
      </a-select>
    </a-form-item>
    <a-form-item v-bind="formItemLayout" label=" ">
      <a-select
        v-decorator="[
          'address1',
          {
            rules: [{ validator: validateAddress1 }],
            validateTrigger: ['change', 'blur'],
            initialValue: user.address1 || undefined
          }
        ]"
        :get-popup-container="triggerNode => triggerNode.parentNode"
        class="w-100"
        placeholder="市区町村"
      >
        <a-icon slot="suffixIcon" type="caret-down" class="srp-darkest" />
        <a-select-option
          v-for="city in mapCitiesByState"
          :key="city"
        >
          {{ city }}
        </a-select-option>
      </a-select>
    </a-form-item>
    <a-form-item v-bind="formItemLayout" label=" ">
      <a-input
        v-decorator="[
          'address2',
          {
            rules: [{ validator: validateAddress2 }],
            validateTrigger: ['change', 'blur'],
            initialValue: user.address2
          }
        ]"
        type="text"
        placeholder="[例] 西新宿3-20-2 東京オペラシティタワー36F"
        autocomplete="off"
      />
    </a-form-item>
    <!-- xxx -->

    <a-form-item
      v-bind="formItemLayout"
      :required="true"
      label="電話番号"
      style="margin-bottom:0;"
    >
      <a-form-item
        :style="{ display: 'inline-block', width: 'calc(50% - 30px)' }"
      >
        <a-input
          v-decorator="[
            'tel',
            {
              rules: [{ validator: validateTel }],
              validateTrigger: ['change', 'blur'],
              initialValue: user.tel
            }
          ]"
          placeholder="09091234560"
        />
      </a-form-item>
      <span
        :style="{
          display: 'inline-block',
          width: '60px',
          textAlign: 'center'
        }"
      >
        FAX番号
      </span>
      <a-form-item
        :style="{ display: 'inline-block', width: 'calc(50% - 30px)' }"
      >
        <a-input
          v-decorator="[
            'fax',
            {
              rules: [{ validator: validateFax }],
              validateTrigger: ['change', 'blur'],
              initialValue: user.fax
            }
          ]"
          placeholder="09091234560"
        />
      </a-form-item>
    </a-form-item>

    <div v-if="showSubmit" style="text-align: right;">
      <a-button type="primary" html-type="submit">
        更新する
      </a-button>
    </div>
  </a-form>
</template>

<script>
import { mapGetters, mapActions } from 'vuex'
import { timer } from 'rxjs'

export default {
  name: 'CompanyForm',
  props: {
    showSubmit: {
      type: Boolean,
      default: false
    }
  },
  data () {
    return {
      form: this.$form.createForm(this),

      formItemLayout: {
        colon: false,
        labelCol: {
          xs: { span: 24 },
          sm: { span: 8 }
        },
        wrapperCol: {
          xs: { span: 24 },
          sm: { span: 16 }
        }
      },
      noPostCode: false,
      saving: false,
      notification: null,
      pickState: ''
    }
  },
  computed: {
    ...mapGetters('auth', ['userInfo']),
    user () {
      return this.userInfo || {}
    },
    ...mapGetters('resources', ['states', 'getCitiesByState']),
    mapCitiesByState () {
      if (!this.pickState) { return [] }
      return this.getCitiesByState(this.pickState).map(item => item.cityName)
    }
  },
  methods: {
    displayRender ({ labels }) {
      return labels.join(' - ')
    },
    validateTel (rule, value, callback) {
      if (!value || value.trim() === '') {
        return callback(new Error('電話番号を入力してください'))
      }

      if (value && (value.length > 11 || value.length < 10)) {
        return callback(new Error('正しい電話番号を入力してください'))
      }

      if (value && !this.isNumber(value)) {
        return callback(new Error('正しい電話番号を入力してください'))
      }

      callback()
    },
    validateFax (rule, value, callback) {
      if (value && (value.length > 11 || value.length < 10)) {
        return callback(new Error('正しい電話番号を入力してください'))
      }

      if (value && !this.isNumber(value)) {
        return callback(new Error('正しい電話番号を入力してください'))
      }

      callback()
    },
    validateCompanyName (rule, value, callback) {
      if (!value || value.trim() === '') {
        return callback(new Error('法人名・貴社名を入力してください'))
      }

      if (value.length > 50) {
        return callback(new Error('法人名・貴社名を50文字まで入力してください'))
      }

      callback()
    },
    validateCompanyNameKana (rule, value, callback) {
      if (value && value.length > 50) {
        return callback(new Error('法人名・貴社名を50文字まで入力してください'))
      }

      if (value && !this.isKana(value)) {
        return callback(new Error('カタカナで入力してください。'))
      }
      callback()
    },
    // TODO
    isKana (value) {
      const reg = /^([ァ-ヶー]+)$/
      return reg.test(value)
    },
    validatePostCode (rule, value, callback) {
      if (!value || value.trim() === '') {
        return callback(
          new Error('数値のみ、ハイフン(-)無しの7桁の番号を入力してださい')
        )
      }

      if (value.length > 7) {
        return callback(
          new Error('数値のみ、ハイフン(-)無しの7桁の番号を入力してださい')
        )
      }

      if (value && !this.isNumber(value)) {
        return callback(
          new Error('数値のみ、ハイフン(-)無しの7桁の番号を入力してださい11')
        )
      }
      this.noPostCode = false
      callback()
    },

    // TODO

    validateAddress1 (rule, value, callback) {
      if (!value || value.trim() === '') {
        return callback(new Error('市区町村を入力してください'))
      }

      if (value.length > 250) {
        return callback(new Error('住所を250文字まで入力してください'))
      }

      callback()
    },
    validateAddress2 (rule, value, callback) {
      if (value && value.length > 250) {
        return callback(new Error('建物名を250文字まで入力してください'))
      }
      callback()
    },
    isNumber (value) {
      return !isNaN(value)
    },
    ...mapActions('auth', ['updateUserInfo']),
    handleSubmit (e) {
      e.preventDefault()

      this.form.validateFields(async (err, values) => {
        if (!err) {
          this.saving = true
          try {
            await this.updateUserInfo(values)
            this.setInfo({
              type: 'info',
              message: '情報を変更しました'
            })
          } catch (error) {
            this.setInfo({
              type: 'error',
              message: 'エラーが起こりました。後でやり直してください' || error
            })
          }
          this.saving = false
        }
      })
    },
    setInfo (notification, t = 2000) {
      this.notification = notification

      // auto hide message
      this.$subscribeTo(timer(t), () => {
        this.notification = null
      })
    },
    generateStateCity () {
      const code = this.form.getFieldValue('postCode') || ''
      if (code.toString().length === 7) {
        const preCode = code.substr(0, 3)
        const subCode = code.substr(3)

        fetch(
          `https://madefor.github.io/postal-code-api/api/v1/${preCode}/${subCode}.json`
        )
          .then(response => response.json())
          .then((results) => {
            const addressNode = results.data[0]
            if (addressNode) {
              const {
                prefecture,
                address1,
                address2
              } = addressNode.ja
              const payload = {
                state: prefecture,
                address: address1,
                detail: address2
              }
              this.onSetStateCity(payload)
            }
          })
          .catch(() => {
            this.noPostCode = true
          })
      }
    },
    onSetStateCity (payload) {
      this.form.setFieldsValue({ stateCity: payload.state })
      this.pickState = payload.state
      if (payload.address) {
        this.form.setFieldsValue({ address1: payload.address })
      }
      if (payload.detail) {
        this.form.setFieldsValue({ address2: payload.detail })
      }
    },
    stateChangeHanlde (state) {
      this.pickState = state
      this.form.setFieldsValue({ address1: null })
    }
  }
}
</script>

<style scoped></style>
